#!/usr/bin/env python
# coding: utf-8

# blueproximity
SW_VERSION = '1.2'

# Add security to your desktop by automatically locking and unlocking 
# the screen when you and your phone leave/enter the desk. 
# Think of a proximity detector for your mobile phone via bluetooth.
# requires external bluetooth util hcitool to run
# (which makes it unix only at this time)
# Needed python extensions:
#  ConfigObj (python-configobj)
#  Dependences for the KDE frontend: python-kde, python-qt
#  Bluetooth (python-bluez)
#
#
# KDE frontend
#
# Copyright (C) Big-Cat Software Association, 2007.
#
# GILDE project. 
# (Graphical Interfaces to Learn Debian Easily)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. Please read the COPYING file.
#
#
# API
#
# copyright by Lars Friedrichs <larsfriedrichs@gmx.de>
# this source is licensed under the GPL.
# I'm a big fan of talkback about how it performs!
# I'm also open to feature requests and notes on programming issues, I am no python master at all...
# ToDo List can be found on sourceforge
# follow http://blueproximity.sourceforge.net


import os, sys, string
import time
import threading
from qt import *
import signal
from configobj import ConfigObj
from validate import Validator
import bluetooth
import _bluetooth as bluez
import syslog

#localization:
import locale
import gettext
APP_NAME="blueproximity"
dist_path = '/usr/share/blueproximity/'


image0_data = \
    "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a\x00\x00\x00\x0d" \
    "\x49\x48\x44\x52\x00\x00\x00\x20\x00\x00\x00\x20" \
    "\x08\x06\x00\x00\x00\x73\x7a\x7a\xf4\x00\x00\x02" \
    "\xf1\x49\x44\x41\x54\x58\x85\xed\xd6\x4b\x88\x96" \
    "\x75\x14\x06\xf0\xdf\xe7\x68\x53\xea\x94\x46\xa1" \
    "\x81\x9a\x8a\x65\x52\x24\x76\xc7\x34\x23\x89\x04" \
    "\xb1\x4d\xd8\xa2\x45\x64\x14\x48\x48\xd4\x2a\x28" \
    "\x57\xb6\x88\x36\x15\x81\x8b\xda\x14\xda\x6e\x4c" \
    "\xbc\x20\x84\xda\x4d\xa2\x12\x14\x84\x89\x34\x15" \
    "\x33\x8b\xee\x8e\x76\x99\x2e\xce\x34\x5f\x8b\x73" \
    "\x3e\xfd\x7c\xfd\xee\x4d\x6d\xf2\x81\x77\xf1\x5e" \
    "\xce\x39\xcf\xff\xf9\x3f\xe7\xfc\x5f\xce\xe3\xff" \
    "\x8e\x52\x07\x31\xa3\x30\x03\xb3\x71\x19\x46\xe3" \
    "\x38\x8e\xe2\x53\x0c\x8e\x14\xb9\x22\xae\xc4\xb3" \
    "\xd8\x8f\xdf\xf1\x17\xca\x79\x0d\xe3\x4f\x7c\x8d" \
    "\x57\x31\x3f\x89\x8d\x08\x26\x62\x0d\xbe\xa9\x2a" \
    "\xd8\xec\xfa\x03\x1b\x70\xf5\x3f\x2d\x7e\x1b\x8e" \
    "\xd4\x29\xd2\x8f\x03\xf8\x44\xac\x7c\xb8\xce\x37" \
    "\x8f\xa0\xab\xdd\xc2\x25\xdc\x87\x1f\x0a\x09\x4f" \
    "\x62\x2d\xee\xc0\xe5\x18\x8f\x71\x42\xa5\xb9\x78" \
    "\x06\x07\x0b\x64\x4e\xe1\x39\x8c\x69\x87\xc0\x83" \
    "\x62\x9f\x2b\x49\x86\xb0\x0e\x73\x5a\x88\x9d\x80" \
    "\xd5\x18\x70\xb6\x47\x5e\xd0\xa2\x2f\x16\xe0\x97" \
    "\xaa\xe0\x01\x3c\x2a\xdc\x0f\xdd\xb8\x0a\xcb\xf0" \
    "\x58\xbe\x7b\x00\xd7\xe3\xa2\xaa\x3c\x37\xe1\xf3" \
    "\x02\x89\xa7\x34\xe9\xbc\xc9\xa2\x95\x2a\x41\x27" \
    "\x70\x6f\x06\x5d\x80\xc5\x42\x89\x5d\xf8\xb8\x70" \
    "\x7d\x80\x5e\x3c\x84\xb1\x99\x6f\x4e\x21\x5f\xbf" \
    "\xe8\x90\xd3\x28\x4a\x72\x67\x16\x22\xfa\xf9\x09" \
    "\x6c\xc1\x14\x3c\x8d\x1b\xaa\xbe\x1d\x16\x1e\xe9" \
    "\x42\x4f\x2a\x33\x15\x2b\x71\x17\x5e\xc6\x1e\xdc" \
    "\x8f\xed\x49\xea\x4d\x7c\x9b\x0b\x2a\xd7\x52\x60" \
    "\x02\x9e\x4c\xa6\x2f\x26\xc1\x6b\xb1\x29\x57\xf9" \
    "\x11\xde\x48\x55\x26\xe3\x42\x21\xfb\x44\xdc\x8d" \
    "\x97\xf0\x61\x7e\xfb\x3e\x96\x8a\xad\x5b\x82\xad" \
    "\x49\xb0\x29\xa6\x65\xf1\x71\x98\x8e\x6d\xce\x48" \
    "\xfc\x70\x3e\xaf\x87\x31\xc2\x1b\x6f\x65\xcc\xae" \
    "\x24\x56\xc2\xa2\x56\x8a\x13\xad\x35\x03\x17\xe3" \
    "\xb5\x4c\xf4\x0e\xee\x69\x35\x81\x18\xd3\x1b\x33" \
    "\x76\x07\x66\xa9\xd3\x01\xb5\x06\xc4\x20\x7e\xc2" \
    "\xe3\x58\x98\xcf\xd6\x0a\x2f\x10\x92\x4e\xcd\x77" \
    "\x8b\x71\x73\x12\x1e\xca\xb8\x61\x71\x36\xf4\xe5" \
    "\xfb\x1e\xe1\xab\xf7\x6a\x11\xa8\xc5\xaa\x62\x8e" \
    "\x49\x42\xba\x9d\x62\xac\x96\xc5\x7e\x2f\xc7\x8d" \
    "\x42\xee\x81\x2c\x78\x9d\x30\xf0\x7e\xd1\x09\xdf" \
    "\x09\xf7\xbf\x22\xda\xb4\xae\xf1\x1a\x8d\xc8\x83" \
    "\x99\xf8\xf9\x5c\xd9\xa5\x58\x85\x6b\xb0\x0f\xaf" \
    "\x63\x33\xde\xc6\x6e\x71\x38\xcd\x15\xfd\xff\x19" \
    "\x7e\xc6\x21\x61\xec\x5e\xfc\x56\xab\x48\x23\x02" \
    "\x43\x38\x9c\x44\xba\xb1\x42\x9c\x88\xbd\xc2\xd1" \
    "\x15\xb9\xcb\x99\xfc\x00\x8e\xe1\x96\x24\xde\x87" \
    "\x5f\xf1\x65\x2a\x52\x13\x8d\x08\x9c\xca\xc0\xb2" \
    "\x70\xf0\x42\xd1\x11\xef\xaa\xd3\xc3\xf8\x51\xc8" \
    "\x7d\xbb\x30\xf1\xbe\x24\x51\x17\xa3\x1a\xbd\x14" \
    "\x2b\x24\x14\x38\x22\xfc\x50\x5d\xbc\xcb\xb9\x3e" \
    "\xea\xc3\x5e\xb1\x55\x3d\x0d\xc8\x9e\x4e\xd0\x0a" \
    "\x0e\x0b\x35\x8e\xe7\x7d\x49\x9c\xf5\xf3\x30\x53" \
    "\xec\x73\xbf\xf0\x01\xa1\xc2\x78\x31\x09\x47\x1c" \
    "\x25\xdc\x2a\xc6\xf2\xe8\xbc\x9f\x2e\xc6\x6f\x77" \
    "\xe1\xbb\xa6\x68\xfb\x47\x01\x57\x88\xd1\xbb\xc7" \
    "\x99\x2d\x3a\x99\x64\x26\xe1\xfb\x0e\x72\xb6\x85" \
    "\xb1\xe2\x0c\x28\xa2\x4b\x18\xaf\x2d\x74\xa2\xc0" \
    "\xa0\x68\xd1\x4b\xc4\xa1\x54\x39\x70\xbe\x10\x3f" \
    "\xa6\xff\x19\x66\x8b\xff\xc1\x01\xac\xef\x34\x49" \
    "\xb3\x36\xfc\xd7\xd1\xc9\x16\x54\x30\x84\xaf\xc4" \
    "\xb0\xd9\x24\xa6\xe0\x79\xb4\x8d\xbf\x01\x26\x46" \
    "\xd4\xb2\xb1\xf9\x8d\x01\x00\x00\x00\x00\x49\x45" \
    "\x4e\x44\xae\x42\x60\x82"



# Moved to a separate file:
from proximity_api import *
# Semiprivate method, mut be repeat here:
def _(text):
    return lang.ugettext(text)


''' PyQt and PyKDE Modules'''
from qt import QToolTip, QTimer, QMessageBox, SIGNAL, QIconSet, QPixmap, QListViewItem, QPoint, QCursor
from kdecore import KIcon, KIconLoader, KCmdLineArgs, KAboutData, KUniqueApplication, KStandardDirs, KApplication
from kdeui import KSystemTray, KPopupMenu, KMainWindow
#from dcopexport import DCOPExObj

from kblueproximity_ui import Kproximity_Ui

# Translation for the imported ui file:
# I am sorry for the following code.
# Thanks to pyuic, it cannot be solved in other way.
def trans(Nothing,text):
    return lang.ugettext(text)

Kproximity_Ui.__dict__["_Kproximity_Ui__tr"]=trans

import aboutform


# Setup config file specs and defaults

conf_specs = [
    'device_mac=string(max=17,default="")',
    'device_channel=integer(1,30,default=7)',
    'lock_distance=integer(0,127,default=7)',
    'lock_duration=integer(0,120,default=6)',
    'unlock_distance=integer(0,127,default=4)',
    'unlock_duration=integer(0,120,default=1)',
    'lock_command=string(default=''dcop kdesktop KScreensaverIface lock'')',# KDE
    'unlock_command=string(default=''dcop kdesktop KScreensaverIface quit'')',# KDE
    'proximity_command=string(default=''dcop kdesktop KScreensaverIface enable 0'')',
    'proximity_interval=integer(5,600,default=60)',
    'buffer_size=integer(1,255,default=1)',
    'log_to_syslog=boolean(default=True)',
    'log_syslog_facility=string(default=''local7'')',
    'log_to_file=boolean(default=False)',
    'log_filelog_filename=string(default=''' + os.getenv('HOME') + '/blueproximity.log'')',
    'other_commands=boolean(default=False)'# KDE specific gui
    ]


# set this value to './' for svn version
# or to '/usr/share/blueproximity/' for packaged version


icon_base = 'blueproximity_base.svg'
icon_att = 'blueproximity_attention.svg'
icon_away = 'blueproximity_nocon.svg'
icon_con = 'blueproximity_error.svg'
icon_pause = 'blueproximity_pause.svg'





class ProximityGUI(Kproximity_Ui,KMainWindow):
    # this class represents the main configuration window and
    # updates the config file after changes made are saved

    def __init__ (self, *args):
        apply (Kproximity_Ui.__init__, (self,) + args)

        #This is to block events from firing a config write because we initialy set a value
        self.gone_live = False

        self.setGeometry(430, 60, 370, 485)

# In order to restore KScreensaver state:
        self.KScreensaverState_user = os.popen("dcop kdesktop KScreensaverIface isEnabled").readline()
        self.KScreensaverState_alt2 = self.KScreensaverState_user
        #Constructor sets up the GUI and reads the current config

        # read config if any
        self.new_config = False
        try:
            self.config = ConfigObj(os.getenv('HOME') + '/.kblueproximityrc',{'create_empty':False,'file_error':True,'configspec':conf_specs})
            print "read config: O.K."
        except:
            self.new_config = True
            print "read config: exception, no config file"
        if self.new_config:
            print "new conf1g file"
            self.config = ConfigObj(os.getenv('HOME') + '/.kblueproximityrc',{'create_empty':True,'file_error':False,'configspec':conf_specs})
            print " - default conf."
            # next line fixes a problem with creating empty strings in default values for configobj
            self.config['device_mac'] = ''
        self.vdt = Validator()
        self.config.validate(self.vdt, copy=True)
        self.config.write()
        print "config dev MAC:"
        print self.config['device_mac']

        self.proxi = Proximity(self.config)
        self.proxi.start()
        print "proxi dev MAC:"
        print self.proxi.dev_mac

        self.minDist = -255
        self.maxDist = 0
        self.pauseMode = False

        self.lastMAC = ''

        #Show the current settings

        self.readSettings()

        self.icons = KIconLoader ()

        self.systray = KSystemTray (self)

        self.systray.contextMenuAboutToShow(KPopupMenu("title"))

        QToolTip.add(self.systray, _("BlueProximity starting..."))

        self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_con, KIcon.Desktop, 22)) 

        self.systray.connect (self.systray, SIGNAL("quitSelected()"), self.quit)

        self.imageConf = QPixmap("/usr/share/icons/default.kde/22x22/actions/configure.png")
        self.systray.contextMenu().insertItem(QIconSet(self.imageConf), _("BlueProximity Preferences"), self.showWindow)

        self.imagePause = QPixmap("/usr/share/icons/default.kde/22x22/actions/player_pause.png")
        self.imageStart = QPixmap("/usr/share/icons/default.kde/22x22/actions/player_play.png")
        self.systray.contextMenu().insertItem(QIconSet(self.imagePause), _("Pause"), self.pausePressed)


        self.systray.contextMenu().insertTitle(_("HELP & ABOUT"))
        self.systray.contextMenu().insertItem(_("Help"), self.slotHelp)

        self.systray.contextMenu().insertItem(_("About K-Blueproximity"), self.aboutPressed)
        self.systray.contextMenu().insertItem(_("About QT"), self.slotAboutQT)

        self.systray.show ()


#        self.image0.loadFromData(image0_data,"PNG")
#        self.systray.contextMenu().changeItem(self.systray.contextMenu().idAt(2), QIconSet(self.imageStop), "SPause")
#        self.systray.contextMenu().changeItem(self.systray.contextMenu().idAt(2), "Start")


# Init. scan disabled
#        self.btnScan_clicked()

        #Only show if we started unconfigured
        if self.new_config:
            print "Setting popup variable to True"
            self.systray.setActive()
            self.popupActive = True
        else:
            print "Now setting popup variable to False"
            self.systray.setInactive()
            self.popupActive = False

        koordin=self.systray.mapFromGlobal(QPoint(0,0))
        koord2=koordin.x()
        koord3=koordin.y()
        print "koordinata:"
        print koord2
        print koord3


# timer1,2 shot regularly:
        self.time = QTimer(self)
        self.connect(self.time, SIGNAL('timeout()'), self.updateState)
        self.time.start(1000)

        self.time2 = QTimer(self)
        self.connect(self.time2, SIGNAL('timeout()'), self.proximityCommand)


        self.slotActionPolicy()


# Maybe KDE also need similar
#        self.connect(app, SIGNAL("shutDown()"), self.slotQuit)
#
#    def slotQuit(self):
#        self.deleteLater()
#        app.quit()

        #now the control may fire change events
        self.gone_live = True
#        self.proxi.logger.log_line(_('started.'))
        self.proxi.logger.log_line('started.')

#-----------------------------------------------------------------------------------------
# Slider value displays
#-----------------------------------------------------------------------------------------

    def slotLdistance(self):
        self.lineEditLockDist.setText(str(self.hscaleLockDist.value()))

# negative or positive
    def slotLdistance(self):
        self.lineEditLockDist.setText(str(self.hscaleLockDist.value()))
        if -self.proxi.active_limit > self.hscaleLockDist.value():
            self.hscaleUnlockDist.setValue(self.hscaleLockDist.value()-1)
#        else:
#            self.hscaleUnlockDist.setValue(-self.proxi.active_limit)
#  positive!
    def slotLduration(self):
        self.lineEditLockDur.setText(str(self.hscaleLockDur.value()))

    def slotUdistance(self):
        self.lineEditUnlockDist.setText(str(self.hscaleUnlockDist.value()))
        if -self.proxi.gone_limit < self.hscaleUnlockDist.value():
            self.hscaleLockDist.setValue(self.hscaleUnlockDist.value()+1)
#        else:
#            self.hscaleLockDist.setValue(-self.proxi.gone_limit)

    def slotUduration(self):
        self.lineEditUnlockDur.setText(str(self.hscaleUnlockDur.value()))

# Replaced with a progressbar
#    def slotMdistance(self):
#        self.lineEditAct.setText(str(self.sliderMdistance.value()))

    def slotProxi(self):
        self.lineEditProxi.setText(str(self.hscaleProxi.value()))


#-----------------------------------------------------------------------------------------
# A KDE specific method
#-----------------------------------------------------------------------------------------

    def KScreensaverState(self):
        self.KScreensaverState_user = os.popen("dcop kdesktop KScreensaverIface isEnabled").readline()
        return ret_val


#-----------------------------------------------------------------------------------------
# User action methods
#-----------------------------------------------------------------------------------------

    def showWindow(self):
        print "popupstate: ", self.popupActive

        if self.popupActive:
            print "Setting popup variable to False"
            self.popupActive = False
            self.Close()
        else:
            print "Setting popup variable to True"
            self.popupActive = True
            self.proxi.Simulate = True
        print "popupstate: ", self.popupActive
        self.systray.toggleActive()


    def pausePressed(self, widget, data = None):
        if self.pauseMode:
            self.pauseMode = False
            self.proxi.dev_mac = self.lastMAC
            self.proxi.Simulate = False
#            self.icon.set_from_file(dist_path + "blueproximity_error.gif")
            self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_con, KIcon.Desktop, 22))
            self.systray.contextMenu().changeItem(self.systray.contextMenu().idAt(2), QIconSet(self.imageStart), _("Start"))
        else:
            self.pauseMode = True
            self.lastMAC = self.proxi.dev_mac
            self.proxi.dev_mac = ''
            self.proxi.Simulate = True
            self.proxi.kill_connection()
            self.systray.contextMenu().changeItem(self.systray.contextMenu().idAt(2), QIconSet(self.imagePause), _("Pause"))


    def slotHelp(self):
        os.system("khelpcenter /usr/share/doc/blueproximity/manual.html &")


    def aboutPressed(self):
        aboutKBlueProximity = aboutform.AboutForm(self)
        aboutKBlueProximity.show()

    def slotAboutQT(self):
        QMessageBox.aboutQt(self, "About Qt3")

# KDE specific solution, so far
    def slotActionPolicy(self):
        self.time2.stop()
        print "timer2 has been stopped"

        self.kscreensaverstate()

        if self.groupBoxAction.isChecked():
            self.comboAction.setEnabled(0)
            self.groupBoxProximity.setEnabled(1)
            self.time2.start(1000*self.config['proximity_interval'], False)
            print "starting timer2..."
        else:
            self.comboAction.setEnabled(1)

            if self.comboAction.currentItem()==0:
                self.groupBoxProximity.setEnabled(0)

            else:
                self.groupBoxProximity.setEnabled(1)
                self.time2.start(1000*self.config['proximity_interval'], False)
                print "starting timer2..."

        self.KScreensaverState_alt2 = os.popen("dcop kdesktop KScreensaverIface isEnabled").readline()


#-----------------------------------------------------------------------------------------
# Service methods
#-----------------------------------------------------------------------------------------

# In order to reset KDE screensaver state
    def kscreensaverstate(self):

        # KDE screensaver changed:
        self.KScreensaverState_alt1 = os.popen("dcop kdesktop KScreensaverIface isEnabled").readline()
        if self.KScreensaverState_alt1==self.KScreensaverState_alt2:
            print "KScreensaver state has not been changed by the user"
            print "Current state: ", self.KScreensaverState_user
        else:
            print "KScreensaver state has been changed by the user"
            if self.KScreensaverState_user=="true\n":
                self.KScreensaverState_user="false\n"
                print "Current state: ", self.KScreensaverState_user
            else:
                self.KScreensaverState_user="true\n"
                print "Current state: ", self.KScreensaverState_user


    def slotChangeTimer(self):
        self.time2.stop()
        self.time2.start(1000*self.config['proximity_interval'], False)


    def readSettings(self):

        self.entryMAC.setText(self.proxi.dev_mac)

        self.hscaleLockDist.setValue(-self.proxi.gone_limit)
        self.lineEditLockDist.setText(str(-self.proxi.gone_limit))

        self.hscaleLockDur.setValue(self.proxi.gone_duration)
        self.lineEditLockDur.setText(str(self.proxi.gone_duration))

        self.hscaleUnlockDist.setValue(-self.proxi.active_limit)
        self.lineEditUnlockDist.setText(str(-self.proxi.active_limit))

        self.hscaleUnlockDur.setValue(self.proxi.active_duration)
        self.lineEditUnlockDur.setText(str(self.proxi.active_duration))

# Tab page 3
        if self.config['other_commands']:

            self.groupBoxAction.setChecked(1)

            self.entryLock.setText(self.config['lock_command'])
            self.entryUnlock.setText(self.config['unlock_command'])
            self.entryProxi.setText(self.config['proximity_command'])

        else:
            self.groupBoxAction.setChecked(0)
# also: setCurrentText
            if self.config['lock_command'] == "xscreensaver-command -lock":
                self.comboAction.setCurrentItem(2)

            if self.config['lock_command'] == "gnome-screensaver-command --lock":
                self.comboAction.setCurrentItem(1)
# Fallback to KScreensaver:
            else:
                self.comboAction.setCurrentItem(0)

        self.hscaleProxi.setValue(self.config['proximity_interval'])
        self.lineEditProxi.setText(str(self.config['proximity_interval']))

        if not self.config['log_to_syslog']:
            self.checkSyslog.setChecked(0)

        self.comboFacility.setCurrentText(self.config['log_syslog_facility'])

        if self.config['log_to_file']:
            self.checkFile.setChecked(1)

        self.entryFile.setText(self.config['log_filelog_filename'])


    def writeSettings(self):

        self.proxi.dev_mac = str(self.entryMAC.text())
        self.proxi.gone_limit = -self.hscaleLockDist.value()
        self.proxi.gone_duration = self.hscaleLockDur.value()
        self.proxi.active_limit = -self.hscaleUnlockDist.value()
        self.proxi.active_duration = self.hscaleUnlockDur.value()
        self.config['device_mac'] = str(self.proxi.dev_mac)
        self.config['lock_distance'] = int(-self.proxi.gone_limit)
        self.config['lock_duration'] = int(self.proxi.gone_duration)
        self.config['unlock_distance'] = int(-self.proxi.active_limit)
        self.config['unlock_duration'] = int(self.proxi.active_duration)


        if self.groupBoxAction.isChecked():
            self.config['other_commands'] = True
# Configurator/gui exception???:
            if self.entryLock.text():
                self.config['lock_command'] = str(self.entryLock.text())
            else:
                self.config['lock_command'] = "NONE"

            if self.entryUnlock.text():
                self.config['unlock_command'] = str(self.entryUnlock.text())
            else:
                self.config['unlock_command'] = "NONE"

            if self.entryProxi.text():
                self.config['proximity_command'] = str(self.entryProxi.text())
            else:
                self.config['proximity_command'] = "NONE"

        else:
            self.config['other_commands'] = False

            if self.comboAction.currentItem()==0:
                self.config['lock_command'] = "dcop kdesktop KScreensaverIface lock"
                self.config['unlock_command'] = "dcop kdesktop KScreensaverIface quit"
                self.config['proximity_command'] = "dcop kdesktop KScreensaverIface enable 0"

            if self.comboAction.currentItem()==1:
                self.config['lock_command'] = "gnome-screensaver-command --lock"
                self.config['unlock_command'] = "gnome-screensaver-command --deactivate"
                self.config['proximity_command'] = "gnome-screensaver-command --poke"

            if self.comboAction.currentItem()==2:
                self.config['lock_command'] = "xscreensaver-command -lock"
                self.config['unlock_command'] = "xscreensaver-command -deactivate"
                self.config['proximity_command'] = "xscreensaver-command -p"


        self.config['proximity_interval'] = int(self.hscaleProxi.value())

        if self.checkSyslog.isChecked():
            self.config['log_to_syslog'] = True
        else:
            self.config['log_to_syslog'] = False

        self.config['log_syslog_facility'] = str(self.comboFacility.currentText())

        if self.checkFile.isChecked():
            self.config['log_to_file'] = True
        else:
            self.config['log_to_file'] = False


        self.config['log_filelog_filename'] = str(self.entryFile.text())
        self.proxi.logger.configureFromConfig(self.config)
# See also on closeEvent:
        self.config.write()


    def btnResetMinMax_clicked(self):
        #Resets the values for the min/max viewer
        self.minDist = -255
        self.maxDist = 0

    def event_settings_changed(self):
        #Don't react if we are still initializing (were we set the values)
        #print "on_settings_changed reached"
        if self.gone_live:
            print "Writing settings to config file..."
            self.writeSettings()
        pass


    def btnClose_clicked(self):

        self.Close()
        self.popupActive = False


    def btnSelect_clicked(self):
        #Takes the selected entry in the mac/name table and enters its mac in the MAC field
        selection_iter=self.listView1.selectedItem() # we may need: .currentItem()
# not set ... as device
        if (selection_iter) and selection_iter.text(0)!="...":
            print "Selected Item: ", selection_iter.text(0)

            self.entryMAC.setText(str(selection_iter.text(0)))

    def btnScan_clicked(self):
        # scan the area for bluetooth devices and show the results
        tmpMac = self.proxi.dev_mac
        self.proxi.dev_mac = ''
        self.proxi.kill_connection()
        # early state error handling
        self.listView1.clear() #
        item = QListViewItem(self.listView1,None)
        item.setText(0,_("Now scanning..."))
        item.setText(1,_("..."))
        self.setCursor(QCursor(3))
        try:
            macs = self.proxi.get_device_list()
        except:
            item.setText(0,_("..."))
            item.setText(1,_("device not found."))
            self.setCursor(QCursor(0))
            return

        self.setCursor(QCursor(0))
        self.proxi.dev_mac = tmpMac
#        self.model.clear()
        self.listView1.clear()
        self.itemList = []
        print "scan finish"

        for mac in macs:
#            self.model.append([mac[0], mac[1]])
            item = ListItem(self.listView1)
            self.itemList.append(item)
            for i in range(len(mac)):
                item.setText(i, mac[i])

    def Close(self):
#        self.window.hide()
        self.config.write()
        self.systray.setInactive()
        self.proxi.Simulate = False

    def quit(self, data = None):
        print "Closing all process...";
# Continued at closeEvent...

# KDE qt closeEvent for clicking on right upside "X":
    def closeEvent(self, ce):
        if self.isVisible():
            print "Close ignored"
            ce.ignore()
            self.Close()
            self.config.write()
            return
# KDE qt closeEvent for exiting from systray:
        else:
        #try to close everything correctly
            self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_att, KIcon.Desktop, 22))
#            self.proxi.logger.log_line(_('stopped.'))
            self.proxi.logger.log_line('stopped.')
            self.proxi.Stop = 1
# From def writeSettings:
            self.config.write()
# Restore KScreenSaver state:
            self.kscreensaverstate()
            if self.KScreensaverState_user=="true\n":
                print "KScreenSaver state have set to: ", self.KScreensaverState_user
                ret_val = os.popen("dcop kdesktop KScreensaverIface enable 1").readlines()
            elif self.KScreensaverState_user=="false\n":
                print "KScreenSaver state have set to: ", self.KScreensaverState_user
                ret_val = os.popen("dcop kdesktop KScreensaverIface enable 0").readlines()

            self.time.stop()
            self.time2.stop()

            self.proxi.join(20)
            if self.proxi.isAlive():
                print "Thread is working!"
            else:
                print "Thread is not working!"

            time.sleep(1)
            print "I hope, all process have been closed.";
            print "- application quit."
            sys.exit()
#            ce.accept()


    def updateState(self):
        print "Triggered update...\n Window is visible:", self.isVisible()

# KDE: there are sevaral ways to make a window visible
        if self.isVisible():
            self.proxi.Simulate = True
        else:
            self.proxi.Simulate = False
        # update the display with newest measurement values
        newVal = int(self.proxi.Dist) # Values are negative!
        if newVal > self.minDist:
            self.minDist = newVal
        if newVal < self.maxDist:
            self.maxDist = newVal

        self.textLabelMdistance.setText("Minimum: " + 
            str(-self.minDist) + _("\nMaximum: ") + str(-self.maxDist) + _("\nState: ") + self.proxi.State)

# KDE: replaced with a progressbar
        self.hscaleAct.setProgress(int(-newVal/255*100))
        self.lineEditAct.setText(str(-newVal))

        print "newval: ", newVal
        #Update icon too
        if self.pauseMode:
            self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_pause, KIcon.Desktop, 22)) 
            QToolTip.add(self.systray, _('Pause Mode - not connected'))
        else:
            if self.proxi.ErrorMsg == _("No connection found, trying to establish one..."):
                self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_con, KIcon.Desktop, 22)) 
            else:
                if self.proxi.State != _('active'):
                    self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_away, KIcon.Desktop, 22))
                else:
                    if newVal < self.proxi.active_limit:
                        self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_att, KIcon.Desktop, 22)) 
                    else:
                        self.systray.setPixmap(self.icons.loadIcon(dist_path + icon_base, KIcon.Desktop, 22)) 
            if self.proxi.Simulate:
                simu = _('\nSimulation Mode (locking disabled)')
            else:
                simu = ''

            QToolTip.add(self.systray, _('Detected Distance: ') + str(-newVal) + _("\nCurrent State: ") + self.proxi.State + _("\nStatus: ") + self.proxi.ErrorMsg + simu)


    def proximityCommand(self):
        #This is the proximity command callback called asynchronously as the updateState above
        ret_val = os.popen(self.config['proximity_command']).readlines()
        print "proximity_command triggered"



#    def __tr(self,s,c = None):
#        return qApp.translate("ProximityGUI",s,c)




# Helper for filling out ListView if we need it in the future
class ListItem(QListViewItem):
        def __init__(self, *args):
                apply(QListViewItem.__init__,(self,) + args)

        def key(self, col, asc):
                return string.rjust(str(self.text(col)),2)  # ADD THIS for KDE

#-----------------------------------------------------------------------------------------
# Future threading template
#-----------------------------------------------------------------------------------------
#
#class Proximity(ProximityAPI, threading.Thread):
#    def __init__(self, parent):
#        ProximityAPI.__init__(self, parent)

#        print "API initialized!"


if __name__=='__main__':

    # react on ^C
    signal.signal(signal.SIGINT, signal.SIG_DFL)

    appName = 'K-Blueproximity'
    programName = 'K-Blueproximity'
    description = 'Securiry via Bluetoth device'
    license = KAboutData.License_GPL
    version = '1.2'
    NameVersion = 'K-Blueproximity 1.2'
    copyright = '(C) 2007 Big Cat Software <triiisz@gmail.com> and Lars Friedrichs <larsfriedrichs@gmx.de>'

    aboutData = KAboutData(appName, programName, version, description, license, copyright)
    aboutData.addAuthor('Trisz', 'Maintainer', 'triiisz@gmail.com')
    aboutData.addAuthor('Lars Friedrichs', 'Contributor [class Proximity]', 'larsfriedrichs@gmx.de')
    sys.argv.extend(['--icon', '/usr/share/blueproximity/blueproximity_base.svg', '--caption', appName+" "+version])
    KCmdLineArgs.init(sys.argv, aboutData)
    #KCmdLineArgs.addCmdLineOptions([('+files', 'File to open')])    

# KDE
    app = KUniqueApplication(True, True, True)

    pGui = ProximityGUI();

    app.setMainWidget(pGui)

#    try:
#        mainWindow.move(1000, 500)
#        mainWindow.setFixedSize(370, 485)
#        if not mainWindow.widgettoembed.checkStartTrayed.isChecked():
#            mainWindow.show()
#    except:
#        mainWindow.show()

# Show function only inside!
#    pGui.show()
    app.exec_loop()

    print "Process has not been closed yet!"
